#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include "usart.h"

volatile uint8_t bitNumber = 0;
volatile uint16_t packet = 0;
volatile uint8_t newPacket = 0;
volatile uint8_t firstHalf = 0;

int main(void) {
	TCCR1B = _BV(CS12) | _BV(WGM12);
	OCR1A = 3125;
	TIMSK = _BV(TICIE1) | _BV(OCIE1A);
	usartInit();
	usartInitPrintf();
	sei();
	set_sleep_mode(SLEEP_MODE_IDLE);
	sleep_enable();
	while (1) {
		sleep_cpu();
		if(newPacket){
			newPacket = 0;
			uint8_t command = packet & 0b00111111;
			printf("<%02d>", command);
		}
	}
}

ISR(TIMER1_CAPT_vect) {
	TCNT1 = 0;
	if (bitNumber) {
		if (ICR1 < 83) firstHalf = !firstHalf;
	}
	if (!firstHalf) {
		packet <<= 1;
		if (!(TCCR1B & _BV(ICES1))) {
			packet |= 1;
		}
		bitNumber++;
		if (bitNumber == 14) newPacket = 1;
	}
	TCCR1B ^= _BV(ICES1);
}

ISR(TIMER1_COMPA_vect) {
	TCCR1B &= ~_BV(ICES1);
	bitNumber = 0;
	packet = 0;
	firstHalf = 0;
}
